Skip to content

Set the width and height of the grid, using either absolute values or values relative to the parent container.

Set your grid’s size

You need to define the grid’s container as a starting point to initialize it. Usually, the div element becomes this container. This container should have defined dimensions as well as the rest of your layout. Handsontable supports relative units such as %, rem, em, vh, vw, and px.

Define the size in your CSS

Both width and height could be defined as inline styles or as a CSS class property. In this case, it’s important to define what should be an overflow parent properly. Handsontable looks for the closest element with overflow: auto or overflow: hidden to use it as a scrollable container. If no such element is found, a window will be used.

Pass the size in the configuration

You can pass width and height values to Handsontable as numbers or possible CSS values for the “width”/“height” properties:

{
width: '100px',
height: '100px',
}

or

{
width: '75%',
height: '75%',
}

or

{
width: 100,
height: 100,
}

These dimensions will be set as inline styles in a container element, and overflow: hidden will be added automatically.

If container is a block element, then its parent has to have defined height. By default block element is 0px height, so 100% from 0px is still 0px.

Changes called in updateSettings() will re-render the grid with the new properties.

Use 'auto' sizing

Set height: 'auto' to make the grid grow to match its content height. Handsontable writes height: auto; overflow: clip; as inline styles on the root element. No internal vertical scrollbar is created, so the page itself scrolls when the grid is taller than the viewport.

{
height: 'auto',
}

You can combine it with width: 'auto' to let the grid follow its parent container’s width:

{
height: 'auto',
width: 'auto',
}

height: 'auto' is different from leaving height unset:

SettingInline styles on rootScroll parentRow virtualization
height: 'auto'height: auto; overflow: clip;The page, outside the gridDisabled, all rows render
height: <number>height: <n>px; overflow: clip;The grid itselfEnabled
height unsetNone, Handsontable does not touch the root inline stylesNearest ancestor with overflow: auto or overflow: hidden, else the windowDepends on the scroll parent

Troubleshooting with 100% height

When the height option is set to 100%, there are three ways to define the container’s height. Assuming you’re creating an Handsontable instance that has 100% height and container is element with id #example.

const container = document.querySelector('#example');
const hot = new Handsontable(container, {
height: '100%',
// ...rest of config
}
  1. Set a fixed height (in pixels) directly on the example element where Handsontable is mounted
<div class="page-wrapper">
<!-- Other HTML element -->
<div id="example" style="height: 500px">
<div class="ht-root-wrapper ht-theme-main">
<div class="ht-grid">
<div class="ht-wrapper">
<!-- Table content -->
</div>
</div>
<!-- Table components -->
</div>
</div>
</div>
  1. Set a fixed height on the parent element, and then give the example itself a height of 100%
<div class="page-wrapper" style="height: 500px">
<!-- Other HTML element -->
<div id="example" style="height: 100%">
<div class="ht-root-wrapper ht-theme-main">
<div class="ht-grid">
<div class="ht-wrapper">
<!-- Table content -->
</div>
</div>
<!-- Table components -->
</div>
</div>
</div>
  1. Use flexbox on the wrapper element to make the example fill the available space
<div class="page-wrapper" style="display: flex; height: 500px">
<!-- Other HTML element -->
<div id="example" style="flex: 1">
<div class="ht-root-wrapper ht-theme-main">
<div class="ht-grid">
<div class="ht-wrapper">
<!-- Table content -->
</div>
</div>
<!-- Table components -->
</div>
</div>
</div>

When using Flexbox, the container automatically expands to fill the available space in the flex container. This is particularly useful when you want the grid to take up all the available space within its parent.

What if the size is not set

If you don’t define any dimensions, Handsontable generates as many rows and columns as needed to fill the available space.

If your grid’s contents don’t fit in the viewport, the browser’s native scrollbars are used for scrolling. For this to work properly, Handsontable’s layout direction (e.g., layoutDirection: 'rtl') must be the same as your HTML document’s layout direction (<html dir='rtl'>). Otherwise, horizontal scrolling doesn’t work.

Autoresizing

Handsontable observes window resizing. If the window’s dimensions have changed, then we check if Handsontable should resize itself too. Due to the performance issue, we use the debounce method to respond on window resize.

You can easily overwrite this behaviour by returning false in the beforeRefreshDimensions hook.

{
beforeRefreshDimensions() { return false; }
}

Manual resizing

The Handsontable instance exposes the refreshDimensions() method, which helps you to resize grid elements properly.

hot.refreshDimensions();

You can listen for two hooks, beforeRefreshDimensions and afterRefreshDimensions.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const triggerBtn = document.querySelector('#triggerBtn');
const example = document.querySelector('#example');
const exampleParent = document.querySelector('#exampleParent');
// generate an array of arrays with dummy data
const data = new Array(100) // number of rows
.fill(null)
.map((_, row) =>
new Array(50) // number of columns
.fill(null)
.map((_, column) => `${row}, ${column}`)
);
const hot = new Handsontable(example, {
data,
rowHeaders: true,
colHeaders: true,
width: '100%',
height: '100%',
colWidths: 100,
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
triggerBtn.addEventListener('click', () => {
if (triggerBtn.textContent === 'Collapse container') {
exampleParent.style.height = ''; // reset to initial 150px;
hot.refreshDimensions();
triggerBtn.textContent = 'Expand container';
} else {
exampleParent.style.height = '410px';
hot.refreshDimensions();
triggerBtn.textContent = 'Collapse container';
}
});
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// Register all Handsontable's modules.
registerAllModules();
const triggerBtn = document.querySelector('#triggerBtn')!;
const example = document.querySelector('#example')!;
const exampleParent = document.querySelector('#exampleParent') as HTMLElement;
// generate an array of arrays with dummy data
const data: string[][] = new Array(100) // number of rows
.fill(null)
.map((_, row) =>
new Array(50) // number of columns
.fill(null)
.map((_, column) => `${row}, ${column}`)
);
const hot = new Handsontable(example, {
data,
rowHeaders: true,
colHeaders: true,
width: '100%',
height: '100%',
colWidths: 100,
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
triggerBtn.addEventListener('click', () => {
if (triggerBtn.textContent === 'Collapse container') {
exampleParent.style.height = ''; // reset to initial 150px;
hot.refreshDimensions();
triggerBtn.textContent = 'Expand container';
} else {
exampleParent.style.height = '410px';
hot.refreshDimensions();
triggerBtn.textContent = 'Collapse container';
}
});
HTML
<div class="example-controls-container">
<div class="controls">
<button id="triggerBtn" class="button button--primary">Expand container</button>
</div>
</div>
<div id="exampleParent"><!-- element with dynamically added styles -->
<div id="example"></div>
</div>
CSS
#exampleParent {
height: 157px;
}
#example {
height: 100%;
}

Related guides

Configuration options

Core methods

Hooks

Result

Your grid now renders at the dimensions you specified, responding to container size or fixed pixel values as configured.

Angular Data GridGrid size

Set the width and height of the grid, using either absolute values or values relative to the parent container.

Set your grid's size

You need to define the grid's container as a starting point to initialize it. Usually, the div element becomes this container. This container should have defined dimensions as well as the rest of your layout. Handsontable supports relative units such as %, rem, em, vh, vw, and px.

Define the size in your CSS

Both width and height could be defined as inline styles or as a CSS class property. In this case, it's important to define what should be an overflow parent properly. Handsontable looks for the closest element with overflow: auto or overflow: hidden to use it as a scrollable container. If no such element is found, a window will be used.

TIP

Handsontable doesn't observe CSS changes for containers out of the box. If you'd like to observe it, you can define the dimensions in the configuration object or create your own observer.

Pass the size in the configuration

You can pass width and height values to Handsontable as numbers or possible CSS values for the "width"/"height" properties:

import { GridSettings } from "@handsontable/angular-wrapper";

gridSettings: GridSettings = {
  height: 100,
  width: 100,
};

or

import { GridSettings } from "@handsontable/angular-wrapper";

gridSettings: GridSettings = {
  height: "75%",
  width: "75%",
};

or

import { GridSettings } from "@handsontable/angular-wrapper";

gridSettings: GridSettings = {
  height: "100px",
  width: "100px",
};
<hot-table [settings]="gridSettings" />

These dimensions will be set as inline styles in a container element, and overflow: hidden will be added automatically.

If container is a block element, then its parent has to have defined height. By default block element is 0px height, so 100% from 0px is still 0px.

Changes called in updateSettings() will re-render the grid with the new properties.

What if the size is not set

If you don't define any dimensions, Handsontable generates as many rows and columns as needed to fill the available space.

If your grid's contents don't fit in the viewport, the browser's native scrollbars are used for scrolling. For this to work properly, Handsontable's layout direction (e.g., layoutDirection: 'rtl') must be the same as your HTML document's layout direction (<html dir='rtl'>). Otherwise, horizontal scrolling doesn't work.

Autoresizing

Handsontable observes window resizing. If the window's dimensions have changed, then we check if Handsontable should resize itself too. Due to the performance issue, we use the debounce method to respond on window resize.

You can easily overwrite this behaviour by returning false in the beforeRefreshDimensions hook.

import { GridSettings } from "@handsontable/angular-wrapper";

gridSettings: GridSettings = {
  beforeRefreshDimensions: () => false,
};
<hot-table [settings]="gridSettings" />

Manual resizing

The Handsontable instance exposes the refreshDimensions() method, which helps you to resize grid elements properly.

TIP

To use the Handsontable API, you'll need access to the Handsontable instance. You can do that by utilizing a reference to the HotTableComponent, and reading its hotInstance property.

For more information, see the Instance access page.

hot.refreshDimensions();

You can listen for two hooks, beforeRefreshDimensions and afterRefreshDimensions.

/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';

@Component({
  selector: 'example-grid-size',
  standalone: false,
  template: `<div class="controls">
      <button
        id="triggerBtn"
        class="button button--primary"
        (click)="btnClick()"
      >
        {{ isContainerExpanded ? 'Collapse container' : 'Expand container' }}
      </button>
    </div>
    <div class="table-container" [style.height.px]="currentHeight">
      <hot-table [data]="data" [settings]="gridSettings"></hot-table>
    </div>`,
})
export class ExampleGridSizeComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  // generate an array of arrays with dummy data
  readonly data = new Array(100) // number of rows
    .fill(null)
    .map((_, row) =>
      new Array(50) // number of columns
        .fill(null)
        .map((_, column) => `${row}, ${column}`)
    );

  isContainerExpanded = false;
  currentHeight = 157;

  readonly gridSettings: GridSettings ={
    rowHeaders: true,
    colHeaders: true,
    width: '100%',
    height: '100%',
    colWidths: 100,
    autoWrapRow: true,
    autoWrapCol: true
  };

  btnClick(): void {
    this.isContainerExpanded = !this.isContainerExpanded;
    this.currentHeight = this.isContainerExpanded ? 410 : 157;

    this.hotTable?.hotInstance?.refreshDimensions();
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { ExampleGridSizeComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ ExampleGridSizeComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ ExampleGridSizeComponent ]
})

export class AppModule { }

Related API reference

React Data GridGrid size

Set the width and height of the grid, using either absolute values or values relative to the parent container.

Set your grid's size

You need to define the grid's container as a starting point to initialize it. Usually, the div element becomes this container. This container should have defined dimensions as well as the rest of your layout. Handsontable supports relative units such as %, rem, em, vh, vw, and px.

Define the size in your CSS

Both width and height could be defined as inline styles or as a CSS class property. In this case, it's important to define what should be an overflow parent properly. Handsontable looks for the closest element with overflow: auto or overflow: hidden to use it as a scrollable container. If no such element is found, a window will be used.

TIP

Handsontable doesn't observe CSS changes for containers out of the box. If you'd like to observe it, you can define the dimensions in the configuration object or create your own observer.

Pass the size in the configuration

You can pass width and height values to Handsontable as numbers or possible CSS values for the "width"/"height" properties:

  <HotTable height={100} width={100} />

or

  <HotTable height="75%" width="75%" />

or

  <HotTable height="100px" width="100px" />

These dimensions will be set as inline styles in a container element, and overflow: hidden will be added automatically.

If container is a block element, then its parent has to have defined height. By default block element is 0px height, so 100% from 0px is still 0px.

Changes called in updateSettings() will re-render the grid with the new properties.

What if the size is not set

If you don't define any dimensions, Handsontable generates as many rows and columns as needed to fill the available space.

If your grid's contents don't fit in the viewport, the browser's native scrollbars are used for scrolling. For this to work properly, Handsontable's layout direction (e.g., layoutDirection: 'rtl') must be the same as your HTML document's layout direction (<html dir='rtl'>). Otherwise, horizontal scrolling doesn't work.

Autoresizing

Handsontable observes window resizing. If the window's dimensions have changed, then we check if Handsontable should resize itself too. Due to the performance issue, we use the debounce method to respond on window resize.

You can easily overwrite this behaviour by returning false in the beforeRefreshDimensions hook.

  <HotTable beforeRefreshDimensions={() => false} />

Manual resizing

The Handsontable instance exposes the refreshDimensions() method, which helps you to resize grid elements properly.

TIP

To use the Handsontable API, you'll need access to the Handsontable instance. You can do that by utilizing a reference to the HotTable component, and reading its hotInstance property.

For more information, see the Instance methods page.

hot.refreshDimensions();

You can listen for two hooks, beforeRefreshDimensions and afterRefreshDimensions.

import { useRef, useState, useEffect } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

// generate an array of arrays with dummy data
const data = new Array(100) // number of rows
  .fill(null)
  .map((_, row) =>
    new Array(50) // number of columns
      .fill(null)
      .map((_, column) => `${row}, ${column}`)
  );

const ExampleComponent = () => {
  const [isContainerExpanded, setIsContainerExpanded] = useState(false);
  const hotRef = useRef(null);
  const triggerBtnClickCallback = () => {
    setIsContainerExpanded(!isContainerExpanded);
  };

  useEffect(() => {
    // simulate layout change outside of React lifecycle
    // @ts-ignore
    document.getElementById('exampleParent').style.height = isContainerExpanded ? '410px' : '157px';
    hotRef.current?.hotInstance?.refreshDimensions();
  });

  return (
    <>
      <div className="controls">
        <button id="triggerBtn" className="button button--primary" onClick={() => triggerBtnClickCallback()}>
          {isContainerExpanded ? 'Collapse container' : 'Expand container'}
        </button>
      </div>
      <div id="exampleParent" className="exampleParent">
        <HotTable
          data={data}
          rowHeaders={true}
          colHeaders={true}
          width="100%"
          height="100%"
          colWidths={100}
          autoWrapRow={true}
          autoWrapCol={true}
          licenseKey="non-commercial-and-evaluation"
          ref={hotRef}
        />
      </div>
    </>
  );
};

export default ExampleComponent;

Related API reference

Skip to content

Set the width and height of the grid, using either absolute values or values relative to the parent container.

Set your grid’s size

You need to define the grid’s container as a starting point to initialize it. Usually, the div element becomes this container. This container should have defined dimensions as well as the rest of your layout. Handsontable supports relative units such as %, rem, em, vh, vw, and px.

Define the size in your CSS

Both width and height could be defined as inline styles or as a CSS class property. In this case, it’s important to define what should be an overflow parent properly. Handsontable looks for the closest element with overflow: auto or overflow: hidden to use it as a scrollable container. If no such element is found, a window will be used.

Pass the size in the configuration

You can pass width and height values to Handsontable as numbers or possible CSS values for the “width”/“height” properties:

const hotSettings = ref({
width: '100px',
height: '100px',
});

or

const hotSettings = ref({
width: '75%',
height: '75%',
});

or

const hotSettings = ref({
width: 100,
height: 100,
});

These dimensions will be set as inline styles in a container element, and overflow: hidden will be added automatically.

If container is a block element, then its parent has to have defined height. By default block element is 0px height, so 100% from 0px is still 0px.

Changes called in updateSettings() will re-render the grid with the new properties.

Use 'auto' sizing

Set height: 'auto' to make the grid grow to match its content height. Handsontable writes height: auto; overflow: clip; as inline styles on the root element. No internal vertical scrollbar is created, so the page itself scrolls when the grid is taller than the viewport.

const hotSettings = ref({
height: 'auto',
});

You can combine it with width: 'auto' to let the grid follow its parent container’s width:

const hotSettings = ref({
height: 'auto',
width: 'auto',
});

height: 'auto' is different from leaving height unset:

SettingInline styles on rootScroll parentRow virtualization
height: 'auto'height: auto; overflow: clip;The page, outside the gridDisabled, all rows render
height: <number>height: <n>px; overflow: clip;The grid itselfEnabled
height unsetNone, Handsontable does not touch the root inline stylesNearest ancestor with overflow: auto or overflow: hidden, else the windowDepends on the scroll parent

Troubleshooting with 100% height

When the height option is set to 100%, there are three ways to define the container’s height. Assuming you’re creating an Handsontable instance that has 100% height and container is element with id #example.

const container = document.querySelector('#example');
const hot = new Handsontable(container, {
height: '100%',
// ...rest of config
}
  1. Set a fixed height (in pixels) directly on the example element where Handsontable is mounted
<div class="page-wrapper">
<!-- Other HTML element -->
<div id="example" style="height: 500px">
<div class="ht-root-wrapper ht-theme-main">
<div class="ht-grid">
<div class="ht-wrapper">
<!-- Table content -->
</div>
</div>
<!-- Table components -->
</div>
</div>
</div>
  1. Set a fixed height on the parent element, and then give the example itself a height of 100%
<div class="page-wrapper" style="height: 500px">
<!-- Other HTML element -->
<div id="example" style="height: 100%">
<div class="ht-root-wrapper ht-theme-main">
<div class="ht-grid">
<div class="ht-wrapper">
<!-- Table content -->
</div>
</div>
<!-- Table components -->
</div>
</div>
</div>
  1. Use flexbox on the wrapper element to make the example fill the available space
<div class="page-wrapper" style="display: flex; height: 500px">
<!-- Other HTML element -->
<div id="example" style="flex: 1">
<div class="ht-root-wrapper ht-theme-main">
<div class="ht-grid">
<div class="ht-wrapper">
<!-- Table content -->
</div>
</div>
<!-- Table components -->
</div>
</div>
</div>

When using Flexbox, the container automatically expands to fill the available space in the flex container. This is particularly useful when you want the grid to take up all the available space within its parent.

What if the size is not set

If you don’t define any dimensions, Handsontable generates as many rows and columns as needed to fill the available space.

If your grid’s contents don’t fit in the viewport, the browser’s native scrollbars are used for scrolling. For this to work properly, Handsontable’s layout direction (e.g., layoutDirection: 'rtl') must be the same as your HTML document’s layout direction (<html dir='rtl'>). Otherwise, horizontal scrolling doesn’t work.

Autoresizing

Handsontable observes window resizing. If the window’s dimensions have changed, then we check if Handsontable should resize itself too. Due to the performance issue, we use the debounce method to respond on window resize.

You can easily overwrite this behaviour by returning false in the beforeRefreshDimensions hook.

const hotSettings = ref({
beforeRefreshDimensions() { return false; },
});

Manual resizing

The Handsontable instance exposes the refreshDimensions() method, which helps you to resize grid elements properly.

hot.refreshDimensions();

You can listen for two hooks, beforeRefreshDimensions and afterRefreshDimensions.

Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const data = new Array(100)
.fill(null)
.map((_, row) =>
new Array(50)
.fill(null)
.map((_, column) => `${row}, ${column}`)
);
const isContainerExpanded = ref(false);
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
function triggerBtnClickCallback() {
isContainerExpanded.value = !isContainerExpanded.value;
const parent = document.getElementById('exampleParent');
if (!parent) {
return;
}
parent.style.height = isContainerExpanded.value ? '410px' : '157px';
hotRef.value?.hotInstance?.refreshDimensions();
}
const hotSettings = ref<GridSettings>({
data,
rowHeaders: true,
colHeaders: true,
width: '100%',
height: '100%',
colWidths: 100,
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example">
<div class="example-controls-container">
<div class="controls">
<button id="triggerBtn" class="button button--primary" @click="triggerBtnClickCallback">
{{ isContainerExpanded ? 'Collapse container' : 'Expand container' }}
</button>
</div>
</div>
<div id="exampleParent" class="exampleParent">
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</div>
</template>
<style>
#exampleParent {
height: 157px;
}
#exampleParent > div {
height: 100%;
}
</style>

Related guides

Configuration options

Core methods

Hooks

Result

Your grid now renders at the dimensions you specified, responding to container size or fixed pixel values as configured.